# -*- coding: utf-8 -*-

from Products.Five.metaclass import makeClass
from Products.Five.security import getSecurityInfo
from Products.Five.browser import BrowserView
from zope.publisher.interfaces.browser import IDefaultBrowserLayer
from Products.CMFPlone.Portal import PloneSite
from Products.Five.security import _getSecurity

from zope.component import getSiteManager, Interface
from Globals import InitializeClass as initializeClass

def register_browser_view(klass, where = None, layer = None, permission = None):
    cdict = getSecurityInfo(klass)
    cdict['__name__'] = klass.name
    new_class = makeClass(klass.__name__, 
                          (klass, BrowserView), cdict)

    if where is None:
        where = PloneSite
    if layer is None:
        layer = IDefaultBrowserLayer
    
    getSiteManager().registerAdapter(new_class,
                                     (where, layer),
                                     Interface,
                                     name = klass.name)
    if permission:
        security = _getSecurity(new_class)
        security.declareObjectProtected(permission)
    initializeClass(new_class)
    
